import matplotlib.pyplot as plt
import numpy as np

#get data from training file
data = np.genfromtxt('train.txt', delimiter = ' ', 
          dtype="float, float, int", names = "col1, col2, col3")
#data_test =  np.genfromtxt('test.txt', delimiter = ' ', 
#          dtype="float, float, int", names = "col1, col2, col3")

#plot column 1, 2, 3 as scatterplot
#from mpl_toolkits.mplot3d import Axes3D
#import pylab
#fig = pylab.figure()
#ax = Axes3D(fig)
#ax.scatter(data["col1"],data["col2"],data["col3"],zdir='z')
#plt.title("Column 1 vs Column 2 vs Column 3")
#plt.show()

#set up colors
import matplotlib.colors as col
import matplotlib.cm as cm
my_colors = ["magenta","cyan"]
my_cmap = col.ListedColormap(my_colors[0:len(my_colors)], 'indexed')
cm.register_cmap(name="mycmap", cmap=my_cmap)

#plot column 1 vs 2 and use 3 to apply color
plt.scatter(data["col1"],data["col2"], c=data["col3"], cmap=cm.get_cmap("mycmap"))
plt.title("Training Data - Column 1 vs Column 2, Colors = Column 3")

#add test data in to view it
#plt.scatter(data_test["col1"],data_test["col2"], c="green")

plt.xlabel("Column 1")
plt.ylabel("Column 2")
plt.show()







#first column data
#print(data["col3"])

#first row data
#print(data[0])

#first row, first column data
#print(data["col1"][0])

#plot column 1
#plt.plot(data["col1"])
#plt.show()

'''
#plot column 1 histogram
plt.hist(data["col1"])
plt.title("Column 1 Histogram")
plt.show()

#plot column 2 histogram
plt.hist(data["col2"])
plt.title("Column 2 Histogram")
plt.show()

#plot column 3 histogram
plt.hist(data["col3"])
plt.title("Column 3 Histogram")
plt.show()

#plot column 1, column 2 as scatterplot
plt.scatter(data["col1"],data["col2"])
plt.title("Column 1 vs Column 2")
plt.show()

#plot column 1, column 3 as scatterplot
plt.scatter(data["col1"],data["col3"])
plt.title("Column 1 vs Column 3")
plt.show()

#plot column 2, column 3 as scatterplot
plt.scatter(data["col2"],data["col3"])
plt.title("Column 2 vs Column 3")
plt.show()
'''

